1 '        ORG     #4000
2 '        LD      HL,#40F2    ;ZEIGER AUF SPEICHER
3 ';                           ;ZEITANGABEN.
4 '        LD      B,#03       ;3ZAHLEN MIT JE
5 'LO:     CALL    #BB06       ;2 ZIFFERN
6 '        RLD                 ;EINGEBEN (HH MM SS) 
7 '        CALL    #BB06
8 '        RLD
9 '        DEC     HL
10 '        DJNZ    LO
11 ';                           ;AENDERN DES IRQ-PROGR.
12 '        DI                  ;SYSTEMINTERRUPT AUS.
13 '        LD      HL,NPR      ;ZEIGER AUF NEUEN
14 ';                           ;SPEICHERINHALT.
15 '        LD      DE,#B939    ;ZEIGER AUF IRG-PROOG....
16 '        LD      BC,#0003    ;3 SPEICHERSTELLEN
17 '        LDIR                ;WERDEN UMKOPIERT.
18 '        INC     BC          ;TAKTZAEHLER
19 '        LD      (#40F4),BC  ;AUF 1 SETZEN.
20 '        EI                  ;SYSTEMINTERRUPT EIN.
21 '        RET                 ;FERTIG...
22 'NPR:    DEFB    #C3,#28,#40 ;JP #4028
23 ';
24 ';                           ;IRG-EINSPRUNG.
25 '        DI                  ;SYSTEMINTERRUPT AUS.
26 '        PUSH    AF          ;REGISTER RETTEN.
27 '        PUSH    HL
28 '        PUSH    DE
29 '        PUSH    BC
30 '        PUSH    IX
31 '        PUSH    IY
32 '        LD      BC,(#40F4)  ;TAKTZAEHLER LADEN
33 '        DEC     BC          ;HERUNTERZAEHLEN
34 '        LD      (#40F4),BC  ;UND ABSPEICHERN.
35 '        LD      A,B         ;TAKTZAEHLER
36 '        OR      C           ;AUF 0?
37 '        JP      NZ,IRQE     ;WENN NEIN FERTIG.
38 '        LD      BC,#012C    ;SONST WIEDER AUF 300
39 '        LD      (#40F4),BC  ;HOCHSETZEN.
40 '        LD      HL,#40F0    ;SEKUNDENZAEHLER
41 '        LD      E,#60       ;HOECHSTER WERT.
42 '        CALL    TICK        ;HOCHZAEHLEN UND MIT 
43 ';                           ;60 VERGELEICHEN.
44 '        JR      C,UAU       ;ZUR ZEITAUSGABE WENN 
45 ';                           ;60 NICHT ERREICHT.
46 '        INC     HL          ;SONST MIN.ZAEHLER
47 '        CALL    TICK        ;HOCHZAEHLEN UND
48 '        JR      C,UAU       ;ZUR ZEITAUSGABE WENN
49 ';                           ;60 NICHT ERREICHT.
50 '        INC     HL          ;SONST STD.ZAEHLER
51 '        LD      E,#24       ;HOCHZAEHLEN UND MIT
52 '        CALL    TICK        ;24 VERGLEICHEN.
53 ';
54 'UAU:    LD      HL,(#B1C9)  ;BILDSCHIRMOFFSET.
55 '        LD      DE,#47      ;ANFANGSPOSITION DER
56 '        ADD     HL,DE       ;ZIFFERNEINGABE
57 '        LD      A,H         ;AM ENDE DER 1.
58 '        AND     #07         ;ZEILE
59 '        OR      #C0         ;BERECHNEN.
60 '        LD      H,A         
61 '        PUSH    HL          ;BERECHNETE ADRESSE
62 '        POP     IY          ;INS IY-REGISTER.
63 '        LD      IX,#3980    ;BITMUSTER DER ZIFFERN.
64 '        LD      HL,#40F2    ;STUNDENZAEHLER.
65 '        LD      DE,#0800    ;FEINZEILENABSTAND.
66 '        XOR     A           ;AKKU LOESCHEN.
67 '        LD      B,#03       ;3 ZAEHLER
68 'L11:    LD      C,#02       ;MIT JE 2 ZIFFERN.
69 'L1:     RLD                 ;IN DEN AKKU.
70 '        PUSH    AF          ;A ZWISCHENSPEICHERN.
71 '        ADD     A,A         ;DIESE 3 BEFEHLE
72 '        ADD     A,A         ;MULTIPLIZIEREN DIE
73 '        ADD     A,A         ;ZIFFER MIT 8 UM DAS
74 ';                           ;RICHTIGE BITMUSTER ZU
75 ';                           ;ERHALTEN.
76 '        LD      (LX+2),A    ;ABSPEICHERN NACH DD
77 ';                           ;(ZEILE 112).
78 '        CALL    ZAUS        ;ZIFFERNAUSGABE.
79 '        POP     AF          ;AKKU HOLEN.
80 '        INC     IY          ;NAECHSTE BILDS.POSITION
81 '        DEC     C           ;BEIDE ZIFFERN
82 '        JP      NZ,L1       ;SCHON AUSGEGEBEN ?
83 '        RLD                 ;BYTE WIEDERHERSTELLEN.
84 '        INC     IY          ;LEERSTELLE LASSEN.
85 '        DEC     HL          ;NAECHSTER ZAEHLER.
86 '        DJNZ    L11         ;ZEITAUSGABE FERTIG ?
87 'IRQE:   POP     IY          ;WENN JA REGISTER
88 '        POP     IX          ;VOM STAPEL HOLEN        
89 '        POP     BC
90 '        POP     DE
91 '        POP     HL        
92 '        POP     AF
93 '        EX      AF,AF'      ;UEBERSCHRIEBENE
94 '        JP      C,#B970     ;BEFEHLE NACHHOLEN,
95 '        JP      #B93D       ;UND ZUM SYSTEMIRQ.
96 ';
97 'TICK:   LD      A,(HL)      ;ZAEHLERSTAND HOLEN.
98 '        INC     A           ;HOCHZAEHLEN.
99 '        DAA                 ;DEZIMALABGLEICH.
100 '        LD      (HL),A      ;ABSPEICHERN.
101 '        CP      E           ;HOECHSTSTAND ?
102 '        RET     C           ;WENN NEIN,FERTIG.
103 '        XOR     A           ;SONST AUF NULL
104 '        LD      (HL),A      ;ZURUECKSETZEN.
105 '        RET                 ;FERTIG.
106 ';
107 'ZAUS:   PUSH    IY          ;BENUTZTE
108 '        PUSH    IX          ;REGISTER
109 '        PUSH    BC          ;ZWISCHENSPEICHERN.
110 '        LD      BC,#7F8A    ;UNTERES ROM
111 '        OUT     (C),C       ;FREISCHALTEN.
112 'LX:     LD      A,(IX+#00)  ;BITMUSTER MIT MODI-
113 ';                           ;FIZIERTEM DD HOLEN.
114 '        LD      (IY+#00),A  ;IN DEN BILDS.SPEICHER.
115 '        INC     IX          ;NAECHSTES BBYTE.
116 '        ADD     IY,DE       ;NAECHSTE FEINZEILE.
117 '        JP      NC,LX       ;ZEICHEN FERTIG ?
118 '        LD      BC,#7F8E    ;UNTERES ROM
119 '        OUT(C),C            ;SPERREN.
120 '        POP     BC          ;ALTE REGISTER-
121 '        POP     IX          ;INHALTE
122 '        POP     IY          ;HOLEN.
123 '        RET                 ;ZUM HAUPTPROG.
124 ';UHR.ASM
125 '
 SPEICHER
;                           ;ZEITANGABEN.
        LD  