.z80
;
;********************************************
;*   Umschaltung                            *
;*           eingebautes Laufwerk wird B:   *
;*           5 1/4 Zoll Laufwerk wird  A:   *
;*                                          *
;*   c     Michael Lutz     27.08.1988      *
;*                                          *
;* Programm wird in einem kleinen freien    *
;* Bereich des BIOS untergebracht           *
;* Es leitet nur den BIOS Call SELDSK um    *
;********************************************
;
neu	equ	0ff02h		;Adresse der Routine im BIOS

start:	ld	hl,rout		;Routine nach NEU kopieren
	ld	de,neu
	ld	bc,routend-rout
	ldir

	ld	hl,bios		;BIOS Call SELDSK umbiegen
	ld	de,0fc1bh
	ld	bc,biosend-bios
	ldir

rout:	.phase  neu
	ld	a,c		; Selektiertes Laufwerk
	or	a		; ist Laufwerk A: ?
	jp	nz,l1		; wenn nein, Sprung nach l1
	ld	c,1		; wenn ja, => Laufwerk wird B:
	jp	l2		; zurueck zum BIOS
l1:	ld	a,c		; Selektiertes Laufwerk
	cp	01		; ist Laufwerk B: ?
	jp	nz,l2		; wenn nein, zurueck zum BIOS
	ld	c,0		; wenn ja, => Laufwerk bird A:
l2:	jp	0fe06h		; zurueck zum BIOS
	.dephase 
routend:

bios:	jp	neu		; neuer BIOS Call
biosend:

	end	start
k bird A:
l2:	jp	0fe06h		; zurueck zum BIOS
	.dephase 
routend:

bi